"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.send = void 0;
const url = "https://oapi.dingtalk.com/robot/send?access_token=4cb5640f1f79869eeeb77017bf1f71cd739ae2aedca5c19b9fb9506a9125d519";
const node_fetch_1 = __importDefault(require("node-fetch"));
require("log-timestamp");
function send(params) {
    return __awaiter(this, void 0, void 0, function* () {
        if (params === null)
            return;
        let body = {
            "at": {
                "isAtAll": true
            },
            "msgtype": "markdown",
            "markdown": {
                "title": "Binance报警",
                "text": `
### Token
${params.token} 
### Chain
${params.chain}
### Rule
${params.rule}
### AlarmInfo
- curr: ${params.alarmInfo.curr}
- last: ${params.alarmInfo.last}
- firstToday: ${params.alarmInfo.firstToday}
- 24h: ${params.alarmInfo.delta1}
- All: ${params.alarmInfo.delta2}
- detail: ${params.alarmInfo.detail}
### TIME: 
${params.datetime}
            `
            }
        };
        let res = yield (0, node_fetch_1.default)(url, {
            'method': "POST",
            body: JSON.stringify(body),
            headers: {
                'Content-Type': 'application/json'
            }
        });
        console.log(`the send message is ${JSON.stringify(body)}`);
        const data = yield res.json();
        console.log(data);
        if (data.errmsg != 'ok') {
            console.log(`=====================================> error happens, please check`);
            process.exit(1);
        }
    });
}
exports.send = send;
