const url: string = "https://oapi.dingtalk.com/robot/send?access_token=4cb5640f1f79869eeeb77017bf1f71cd739ae2aedca5c19b9fb9506a9125d519"

import fetch from "node-fetch"
import { AlamerParams } from "./types";

require("log-timestamp")
export async function send(params: AlamerParams | null) {
    if (params === null) return


    let body = {
        "at": {
            "isAtAll": true
        },
        "msgtype": "markdown",
        "markdown": {
            "title": "Binance报警",
            "text": `
### Token
${params.token} 
### Chain
${params.chain}
### Rule
${params.rule}
### AlarmInfo
- curr: ${params.alarmInfo.curr}
- last: ${params.alarmInfo.last}
- firstToday: ${params.alarmInfo.firstToday}
- 24h: ${params.alarmInfo.delta1}
- All: ${params.alarmInfo.delta2}
- detail: ${params.alarmInfo.detail}
### TIME: 
${params.datetime}
            `}
    }
    let res = await fetch(url, {
        'method': "POST",
        body: JSON.stringify(body),
        headers: {
            'Content-Type': 'application/json'
        }
    })
    console.log(`the send message is ${JSON.stringify(body)}`)
    const data = await res.json()
    console.log(data)
    if (data.errmsg != 'ok') {
        console.log(`=====================================> error happens, please check`)
        process.exit(1)
    }

}



