"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getBnb = void 0;
const fetch = require('node-fetch-with-proxy');
const addrs = [
    "bnb1edrs5cukhx060e02u98v9j8spum7vhuqg9ctxd",
    "bnb142q467df6jun6rt5u2ar58sp47hm5f9wvz2cvg",
    "bnb1u2agwjat20494fmc6jnuau0ls937cfjn4pjwtn",
    "bnb1lsmt5a8vqqus5fwslx8pyyemgjtg4y6ugj308t",
    "bnb1fnd0k5l4p3ck2j9x9dp36chk059w977pszdgdz",
    "bnb1jxfh2g85q3v0tdq56fnevx6xcxtcnhtsmcu64m",
    "bnb1m5amny2gs3xdyta6pksmr43zu4727w24syyks7",
    "bnb1panyupy43sazh4dka6fg3s08909ejhqz4k23eg",
    "bnb1ymasdm96ld0v6s38ylvu0qsw0xmhdlhy47tpsg",
    "bnb1tdcrvgjl580p2qv77y0cu2ezk3c80039psx6sh",
    "bnb1e08c39tjpr5fvdh4cfhqmyclrh62ag45qmddud",
    "bnb1lq4s05lgat8d0qh275q0elt4m9rs760m0ryced",
    "bnb1t5fn9faqu5aanvexqu8dt9tah4jg20eun8gsee",
    "bnb1dkckvfuqv7fjl902cvuqmde27skk94kjp09j99",
    "bnb14u5qnp4peug4a6wlz327mx9xjd0xf6phe7ew8u",
    "bnb19fk9hqqlp8xcwrt0w35weyufnglp43hlthev3l",
    "bnb1uexf06gd94qsxdmqamk360d893dsrm8lvwyjsd",
    "bnb1uwdm6vrfvx43wqj8cj3h362kad0g0nrk3gumg8",
    "bnb1a5f0ghn3c2whfmz3z0wjggwcgsk2t26ynqn68x",
    "bnb1s3czyqxaf4hyt3rueg9gss08nfnvxjzy5qfu2p",
    "bnb1yud0r5kz3ctu07fwax3j753ueef6d0n0uxrx94",
    "bnb1fxk3lmfu2h0qhywdump0hvggg6prlge88f42n9",
    "bnb1erq4ykp99sm87tsrfg8mgjef350gqtzhsqwys6",
    "bnb1u70jtt2umum4ag3vcpw2h8v8levm47t0mtjwmh",
    "bnb1xrfwzlu9c5208lhtn7ywt0mjrhjh4nt4fjyqxy"
];
function sleep(ms) {
    return new Promise(resolve => setTimeout(resolve, ms));
}
function findBNBAmount(data) {
    if (data == null || data.balances == null)
        return 0;
    let balances = data === null || data === void 0 ? void 0 : data.balances;
    for (let i = 0; i < balances.length; i++) {
        let symbol = balances[i].symbol;
        if (symbol == "BNB") {
            return balances[i].free.split('.')[0];
        }
    }
    return 0;
}
function getBnbByAddr(addr) {
    return __awaiter(this, void 0, void 0, function* () {
        yield sleep(200);
        let url = `https://dex.binance.org/api/v1/account/${addr}`;
        // let url = 'https://testnet-dex.binance.org/api/v1/account/tbnb185tqzq3j6y7yep85lncaz9qeectjxqe5054cgn'
        try {
            let res = yield fetch(url, {
                method: 'GET',
                headers: { 'Content-Type': 'application/json' }
            });
            if (res.status != 200)
                return 0;
            let data = yield res.json();
            let address = data.address;
            let amount = findBNBAmount(data);
            return address == addr ? amount : 0;
        }
        catch (e) {
            console.log(e);
            process.exit(1);
        }
        return 0;
    });
}
function getBnb() {
    return __awaiter(this, void 0, void 0, function* () {
        let res = [];
        for (let i = 0; i < addrs.length; i++) {
            let ACCOUNT = addrs[i];
            let balance = yield getBnbByAddr(ACCOUNT);
            res.push({
                "account": ACCOUNT,
                "balance": balance,
                "decimals": 0,
                "symbol": "BNB",
                "chain": "BNB"
            });
        }
        console.log(res);
        return res;
    });
}
exports.getBnb = getBnb;
// getBnb();
