"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getBtc = void 0;
const node_fetch_1 = __importDefault(require("node-fetch"));
const addrs = [
    "34xp4vRoCGJym3xR7yCVPFHoCNxv4Twseo",
    "3LYJfcfHPXYJreMsASk2jkn69LWEYKzexb",
    "3M219KR5vEneNb47ewrPfWyb5jQ2DjxRP6",
    "bc1qm34lsc65zpw79lxes69zkqmk6ee3ewf0j77s3h"
];
function findBTCAmount(data, expectedAddr) {
    var _a;
    if (data == null || data.response == null)
        return 0;
    let response = data === null || data === void 0 ? void 0 : data.response[0];
    let addr = response.addr;
    let amount = (_a = response.confirmed + response.unconfirmed) !== null && _a !== void 0 ? _a : 0;
    if (addr == expectedAddr) {
        return amount;
    }
    return 0;
}
function sleep(ms) {
    return new Promise(resolve => setTimeout(resolve, ms));
}
function getBtcByAddr(addr) {
    return __awaiter(this, void 0, void 0, function* () {
        yield sleep(200);
        let url = "https://www.blockonomics.co/api/balance";
        const APIKEY = "gXXlZWMHUtd8z36YjQsLOcZ2UcSyP4PaTrawBrjQTnI";
        let postData = { "addr": addr };
        try {
            let res = yield (0, node_fetch_1.default)(url, {
                body: JSON.stringify(postData),
                method: 'POST',
                headers: {
                    'Content-Type': 'application/json',
                    'User-Agent': 'blockonomics',
                    'Accept': 'application/json',
                    'Authorization': 'Bearer ' + APIKEY
                }
            });
            // console.log(res)
            if (res.status != 200)
                return 0;
            let data = yield res.json();
            let amount = findBTCAmount(data, addr);
            return amount;
        }
        catch (e) {
            console.log(e);
            process.exit(1);
        }
        return 0;
    });
}
function getBtc() {
    return __awaiter(this, void 0, void 0, function* () {
        let res = [];
        for (let i = 0; i < addrs.length; i++) {
            let ACCOUNT = addrs[i];
            let balance = yield getBtcByAddr(ACCOUNT);
            res.push({
                "account": ACCOUNT,
                "balance": balance.toString(),
                "decimals": 8,
                "symbol": "BTC",
                "chain": "BTC"
            });
        }
        console.log(res);
        return res;
    });
}
exports.getBtc = getBtc;
// getBtc()
