import { BinanceInfo } from "./types"

import fetch from "node-fetch"
const addrs = [
    "34xp4vRoCGJym3xR7yCVPFHoCNxv4Twseo",
    "3LYJfcfHPXYJreMsASk2jkn69LWEYKzexb",
    "3M219KR5vEneNb47ewrPfWyb5jQ2DjxRP6",
    "bc1qm34lsc65zpw79lxes69zkqmk6ee3ewf0j77s3h"
]
function findBTCAmount(data: any, expectedAddr: string) {

    if (data == null || data.response == null) return 0
    let response = data?.response[0]
    let addr = response.addr
    let amount = response.confirmed + response.unconfirmed ?? 0
    if (addr == expectedAddr) {
        return amount
    }
    return 0;
}
function sleep(ms: number) {
    return new Promise(resolve => setTimeout(resolve, ms));
}
async function getBtcByAddr(addr: string) {
    await sleep(200)
    let url = "https://www.blockonomics.co/api/balance"
    const APIKEY = "gXXlZWMHUtd8z36YjQsLOcZ2UcSyP4PaTrawBrjQTnI"
    let postData = { "addr": addr }
    try {
        let res = await fetch(url, {
            body: JSON.stringify(postData),
            method: 'POST',
            headers: {
                'Content-Type': 'application/json',
                'User-Agent': 'blockonomics',
                'Accept': 'application/json',
                'Authorization': 'Bearer ' + APIKEY
            }
        })
        // console.log(res)
        if (res.status != 200) return 0
        let data = await res.json()

        let amount = findBTCAmount(data, addr)
        return amount



    } catch (e) {
        console.log(e)
        process.exit(1)
    }
    return 0

}
export async function getBtc() {
    let res: Array<BinanceInfo> = []
    for (let i = 0; i < addrs.length; i++) {
        let ACCOUNT = addrs[i]
        let balance = await getBtcByAddr(ACCOUNT)
        res.push({
            "account": ACCOUNT,
            "balance": balance.toString(),
            "decimals": 8,
            "symbol": "BTC",
            "chain": "BTC"
        })

    }
    console.log(res)
    return res;
}

// getBtc()