-- Active: 1660702011366@@47.74.235.176@3206@binance

-- DROP TABLE IF EXISTS `binance_info`;

-- CREATE TABLE

--     `binance_info` (

--         `id` int(11) NOT NULL AUTO_INCREMENT,

--         `chain` varchar(255) NOT NULL,

--         `roundId` INTEGER NOT NULL,

--         `symbol` varchar(255),

--         `decimals` integer,

--         `balance` varchar(255),

--         `account` varchar(255),

--         `amount` BIGINT,

--         `day` TIMESTAMP,

--         `createdAt` DATETIME,

--         `updatedAt` DATETIME,

--         PRIMARY KEY (`id`)

--     );

drop table
    if EXISTS `record_balance_ethereum_binance_wallet_balance`;

CREATE TABLE
    `record_balance_ethereum_binance_wallet_balance` (
        `id` int NOT NULL AUTO_INCREMENT COMMENT 'id',
        `pool_address` varchar(255) NOT NULL COMMENT '资产池合约地址',
        `token_address` varchar(255) NOT NULL COMMENT '通证合约地址',
        `balance` decimal(50, 20) NOT NULL COMMENT '持有数量',
        `chain_id` int NOT NULL COMMENT '链id',
        `timestamp` int NOT NULL COMMENT '时间戳',
        `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
        `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '修改时间',
        PRIMARY KEY (`id`),
        UNIQUE KEY `balance_idx` (
            `pool_address`,
            `token_address`,
            `create_time`
        ) USING BTREE COMMENT '通证+资产池+时间全局唯一索引'
    ) ENGINE = InnoDB DEFAULT CHARSET = utf8mb4;

drop table
    if EXISTS `record_balance_bitcoin_binance_wallet_balance`;

CREATE TABLE
    `record_balance_bitcoin_binance_wallet_balance` (
        `id` int NOT NULL AUTO_INCREMENT COMMENT 'id',
        `pool_address` varchar(255) NOT NULL COMMENT '资产池合约地址',
        `token_address` varchar(255) NOT NULL COMMENT '通证合约地址',
        `balance` decimal(50, 20) NOT NULL COMMENT '持有数量',
        `chain_id` int NOT NULL COMMENT '链id',
        `timestamp` int NOT NULL COMMENT '时间戳',
        `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
        `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '修改时间',
        PRIMARY KEY (`id`),
        UNIQUE KEY `balance_idx` (
            `pool_address`,
            `token_address`,
            `create_time`
        ) USING BTREE COMMENT '通证+资产池+时间全局唯一索引'
    ) ENGINE = InnoDB DEFAULT CHARSET = utf8mb4;

drop table if EXISTS `record_balance_trx_binance_wallet_balance`;

CREATE TABLE
    `record_balance_trx_binance_wallet_balance` (
        `id` int NOT NULL AUTO_INCREMENT COMMENT 'id',
        `pool_address` varchar(255) NOT NULL COMMENT '资产池合约地址',
        `token_address` varchar(255) NOT NULL COMMENT '通证合约地址',
        `balance` decimal(50, 20) NOT NULL COMMENT '持有数量',
        `chain_id` int NOT NULL COMMENT '链id',
        `timestamp` int NOT NULL COMMENT '时间戳',
        `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
        `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '修改时间',
        PRIMARY KEY (`id`),
        UNIQUE KEY `balance_idx` (
            `pool_address`,
            `token_address`,
            `create_time`
        ) USING BTREE COMMENT '通证+资产池+时间全局唯一索引'
    ) ENGINE = InnoDB DEFAULT CHARSET = utf8mb4;

drop table if EXISTS `record_balance_bnb_binance_wallet_balance`;

CREATE TABLE
    `record_balance_bnb_binance_wallet_balance` (
        `id` int NOT NULL AUTO_INCREMENT COMMENT 'id',
        `pool_address` varchar(255) NOT NULL COMMENT '资产池合约地址',
        `token_address` varchar(255) NOT NULL COMMENT '通证合约地址',
        `balance` decimal(50, 20) NOT NULL COMMENT '持有数量',
        `chain_id` int NOT NULL COMMENT '链id',
        `timestamp` int NOT NULL COMMENT '时间戳',
        `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
        `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '修改时间',
        PRIMARY KEY (`id`),
        UNIQUE KEY `balance_idx` (
            `pool_address`,
            `token_address`,
            `create_time`
        ) USING BTREE COMMENT '通证+资产池+时间全局唯一索引'
    ) ENGINE = InnoDB DEFAULT CHARSET = utf8mb4;

drop table if EXISTS `record_balance_bsc_binance_wallet_balance`;

CREATE TABLE
    `record_balance_bsc_binance_wallet_balance` (
        `id` int NOT NULL AUTO_INCREMENT COMMENT 'id',
        `pool_address` varchar(255) NOT NULL COMMENT '资产池合约地址',
        `token_address` varchar(255) NOT NULL COMMENT '通证合约地址',
        `balance` decimal(50, 20) NOT NULL COMMENT '持有数量',
        `chain_id` int NOT NULL COMMENT '链id',
        `timestamp` int NOT NULL COMMENT '时间戳',
        `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
        `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '修改时间',
        PRIMARY KEY (`id`),
        UNIQUE KEY `balance_idx` (
            `pool_address`,
            `token_address`,
            `create_time`
        ) USING BTREE COMMENT '通证+资产池+时间全局唯一索引'
    ) ENGINE = InnoDB DEFAULT CHARSET = utf8mb4;

DROP table if EXISTS global_params;

create table
    `global_params` (
        `id` int NOT NULL AUTO_INCREMENT COMMENT 'id',
        `keyStr` varchar(255) NOT NULL,
        `valueString` varchar(255) NOT NULL DEFAULT '',
        `valueInt` BIGINT NOT NULL,
        `timestamp` int NOT NULL COMMENT '时间戳',
        `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
        `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '修改时间',
        PRIMARY KEY (`id`),
        UNIQUE KEY `balance_idx` (
            `keyStr`,
            `valueInt`,
            `valueString`
        ) USING BTREE
    ) ENGINE = InnoDB DEFAULT CHARSET = utf8mb4;

SELECT sum(balance)
FROM
    record_balance_ethereum_binance_wallet_balance AS a
WHERE
    token_address = '0xEeeeeEeeeEeEeeEeEeEeeEEEeeeeEeeeeeeeEEeE'
    and timestamp = (
        SELECT TIMESTAMP
        FROM
            record_balance_ethereum_binance_wallet_balance
        ORDER BY
            TIMESTAMP DESC
        LIMIT 1
    )
SELECT sum(balance)
FROM
    record_balance_ethereum_binance_wallet_balance AS a
WHERE
    token_address = '0xEeeeeEeeeEeEeeEeEeEeeEEEeeeeEeeeeeeeEEeE'
    and timestamp = (
        SELECT TIMESTAMP
        FROM
            record_balance_ethereum_binance_wallet_balance
        where
            Date(now()) = Date(FROM_UNIXTIME(timestamp))
        ORDER BY TIMESTAMP
        LIMIT 1
    )
select value
from global_params
where
    key = 'ETH_Last_Timestamp'
order by timestamp desc
limit 1