"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getTableNameByChain = exports.symbolToAddrByChain = exports.chainToChainId = exports.parseBatch = exports.parseBinanceInfoToDb = exports.ETH_ETH = exports.ETH_BNB = exports.ETH_BUSD = exports.ETH_USDC = exports.ETH_USDT = exports.TRX_USDC = exports.TRX_USDT = exports.BSC_BNB = exports.BNB_BNB = exports.BTC = exports.BSC_TABLE_NAME = exports.BNB_TABLE_NAME = exports.TRX_TABLE_NAME = exports.BTC_TABLE_NAME = exports.ETH_TABLE_NAME = exports.GLOBAL_PARAMS_TABLE = exports.connectionInfo = void 0;
const dayjs_1 = __importDefault(require("dayjs"));
const ethers_1 = require("ethers");
// export const connectionInfo: string = 'mysql://root:admin123@localhost:3306/monitor';
// export const connectionInfo: string = 'mysql://root:admin123@localhost:3306/binance';
exports.connectionInfo = 'mysql://root:123456@47.74.235.176:3206/binance';
exports.GLOBAL_PARAMS_TABLE = 'global_params';
exports.ETH_TABLE_NAME = "record_balance_ethereum_binance_wallet_balance";
exports.BTC_TABLE_NAME = "record_balance_bitcoin_binance_wallet_balance";
exports.TRX_TABLE_NAME = "record_balance_trx_binance_wallet_balance";
exports.BNB_TABLE_NAME = "record_balance_bnb_binance_wallet_balance";
exports.BSC_TABLE_NAME = "record_balance_bsc_binance_wallet_balance";
exports.BTC = "BTC";
exports.BNB_BNB = "BNB_BNB";
exports.BSC_BNB = "0xbb4CdB9CBd36B01bD1cBaEBF2De08d9173bc095c";
exports.TRX_USDT = "TR7NHqjeKQxGTCi8q8ZY4pL8otSzgjLj6t";
exports.TRX_USDC = "TEkxiTehnzSmSe2XqrBj4w32RUN966rdz8";
exports.ETH_USDT = "0xdAC17F958D2ee523a2206206994597C13D831ec7";
exports.ETH_USDC = "0xA0b86991c6218b36c1d19D4a2e9Eb0cE3606eB48";
exports.ETH_BUSD = "0x4Fabb145d64652a948d72533023f6E7A623C7C53";
exports.ETH_BNB = "0xB8c77482e45F1F44dE1745F52C74426C631bDD52";
exports.ETH_ETH = "0xEeeeeEeeeEeEeeEeEeEeeEEEeeeeEeeeeeeeEEeE";
function parseBinanceInfoToDb(info) {
    let precision = ethers_1.BigNumber.from(10).pow(info.decimals);
    let db = {
        "pool_address": info.account,
        "token_address": symbolToAddrByChain(info.symbol, info.chain),
        "balance": ethers_1.BigNumber.from(info.balance).div(precision).toNumber(),
        "chain_id": chainToChainId(info.chain),
        "timestamp": (0, dayjs_1.default)().unix()
    };
    return db;
}
exports.parseBinanceInfoToDb = parseBinanceInfoToDb;
function parseBatch(infos) {
    let res = [];
    for (let i = 0; i < infos.length; i++) {
        res.push(parseBinanceInfoToDb(infos[i]));
    }
    return res;
}
exports.parseBatch = parseBatch;
function chainToChainId(chain) {
    switch (chain) {
        case "BSC":
            return 56;
        case "ETH":
            return 1;
        case "BTC":
            return -1;
        case "TRX":
            return -2;
        case "BNB":
            return -3;
    }
}
exports.chainToChainId = chainToChainId;
function symbolToAddrByChain(symbol, chain) {
    switch (true) {
        case ((chain === "BTC")): return exports.BTC;
        case ((chain === "BNB")): return exports.BNB_BNB;
        case ((chain === "BSC")): return exports.BSC_BNB;
        case ((chain === "TRX") && (symbol === "USDT")): return exports.TRX_USDT;
        case ((chain === "TRX") && (symbol === "USDC")): return exports.TRX_USDC;
        case ((chain === "ETH") && (symbol === "USDT")): return exports.ETH_USDT;
        case ((chain === "ETH") && (symbol === "USDC")): return exports.ETH_USDC;
        case ((chain === "ETH") && (symbol === "ETH")): return exports.ETH_ETH;
        case ((chain === "ETH") && (symbol === "BUSD")): return exports.ETH_BUSD;
        case ((chain === "ETH") && (symbol === "BNB")): return exports.ETH_BNB;
    }
    return "";
}
exports.symbolToAddrByChain = symbolToAddrByChain;
function getTableNameByChain(chain) {
    switch (true) {
        case (chain === "BTC"): return exports.BTC_TABLE_NAME;
        case (chain === "ETH"): return exports.ETH_TABLE_NAME;
        case (chain === "TRX"): return exports.TRX_TABLE_NAME;
        case (chain === "BSC"): return exports.BSC_TABLE_NAME;
        case (chain === "BNB"): return exports.BNB_TABLE_NAME;
    }
    return "";
}
exports.getTableNameByChain = getTableNameByChain;
